<obituary-form-main>
  <style>
    button:disabled {
      cursor: not-allowed;
    }

    .obituary-form-main .step-title {
      text-transform: uppercase;
    }

    .obituary-form-main .obituary-price {
      color: red;
      font-weight: bolder;
      text-transform: uppercase;
    }

    .btn-next-step:disabled {
      background-color: gray;
      border-color: gray;
    }

    /* stepper */

  </style>

  <div class="obituary-form-main">

    <div class="mb-4">
      <obituary-stepper stepperConfig={ obituaryFormStepperConfig } ref="obituarystepper" currentStep={ currentStep } currentStepIndex={ currentStepIndex }></obituary-stepper>
    </div>

    <div if={ currentStep === stepOnePickType }>
      <obituary-form-type-picker typeConfig={ obituaryFormTypePickerConfig }></obituary-form-type-picker>
    </div>

    <div if={ currentStep === stepTwoPickTemplate }>
      <obituary-form-template-picker templateConfig={ obituaryFormTemplatePickerConfig }></obituary-form-template-picker>
    </div>

    <div if={ currentStep === stepThreePopulateData }>
      <obituary-form-populate-data pickerConfig={ obituaryFormImagePickerConfig }></obituary-form-populate-data>
    </div>

    <div if={ currentStep === stepFourPay }>
      <obituary-form-pay payConfig={ obituaryFormPayConfig }></obituary-form-pay>
    </div>

    <div class="row mt-4 mb-2">
      <div class="col-lg-4 mb-2 order-1 order-lg-0">
        <button class="btn btn-secondary btn-block" if={ showPreviousStepButton } onclick={ previousStep }><i class="far fa-arrow-left"></i> { previousStepLabel }</button>
      </div>

      <div class="col-lg-4 mb-2 order-0 order-lg-1">
        <button class="btn btn-danger btn-block" disabled={ true } if={ showObituaryPrice }>{ priceLabel } { obituaryPrice } { priceCurrencyLabel } / { obituaryPriceEur } EUR</button>
      </div>

      <div class="col-lg-4 mb-2 order-3">
        <button class="btn btn-dark btn-block btn-next-step" if={ showNextStepButton } onclick={ nextStep }>{ nextStepLabel } <i class="far fa-arrow-right"></i></button>
      </div>
    </div>
  </div>

  <script>
    let self = this;

    const api = MainApp.obituaryManager.api;
    const alert = MainApp.alert;

    this.config = this.opts.view.obituaryFormMain.config;
    this.isPrepopulatedObituary = this.opts.view.obituaryFormMain.isPrepopulatedObituary;

    this.obituaryFormTypePickerConfig = this.opts.view.obituaryFormTypePicker;
    this.obituaryFormTemplatePickerConfig = this.opts.view.obituaryFormTemplatePicker;
    this.obituaryFormImagePickerConfig = this.opts.view.obituaryFormImagePicker;
    this.obituaryFormStepperConfig = this.opts.view.obituaryFormStepper;
    this.obituaryFormPayConfig = this.opts.view.obituaryFormPay;

    this.showPreviousStepButton = true;
    this.showNextStepButton = true;

    this.disabledNextStepButton = false;

    this.previousStepLabelTemplate = this.config.previousStepLabel;
    this.nextStepLabelTemplate = this.config.nextStepLabel;
    this.payStepLabelTemplate = this.config.payStepLabel;
    this.finishStepLabelTemplate = this.config.finishStepLabel;
    this.priceLabel = this.config.priceLabel;
    this.priceCurrencyLabel = this.config.priceCurrencyLabel;

    this.confirmModalMessage = this.config.confirmModalMessage;

    this.previousStepLabel = this.previousStepLabelTemplate;
    this.nextStepLabel = this.nextStepLabelTemplate;

    this.stepOnePickType = 'step-one-pick-type';
    this.stepTwoPickTemplate = 'step-two-pick-template';
    this.stepThreePopulateData = 'step-three-populate-data';
    this.stepFourPay = 'step-four-pay';

    this.showObituaryPrice = true;

    this.obituary = {};
    this.obituaryPrice = 0;
    this.obituaryPriceEur = 0;

    this.steps = [
      this.stepOnePickType,
      this.stepTwoPickTemplate,
      this.stepThreePopulateData,
      this.stepFourPay,
    ];

    this.currentStep = this.stepOnePickType;
    this.currentStepIndex = 0;

    if (this.isPrepopulatedObituary) {
      this.obituary = {
        type_id: 1,
        template_id: 1,
      }

      this.currentStep = this.stepThreePopulateData;
      this.currentStepIndex = 2;
    }

    this.on('mount', function() {
      self.configureNavigationButtons();
    });

    nextStep() {
      if (this.currentStep === this.stepThreePopulateData) {
        let obituaryFormSubmittedEvent = new CustomEvent('obituary-form-submitted', {valid: true});
        document.dispatchEvent(obituaryFormSubmittedEvent);

        if (this.disabledNextStepButton) {
          alert.error('Нисте унијели сва потребна поља.');
          return;
        }

        let confirm = window.confirm(this.confirmModalMessage);

        confirm && api.createObituary(this.obituary).then(function(o) {
          self.returnedObituary = o;

          self.currentStepIndex++;
          self.currentStep = self.steps[self.currentStepIndex];
          self.configureNavigationButtons();
          self.scrollToTop();
        }, function(err) {
          let message = '';

          err.responseJSON.forEach(function(e) {
            message += e.message + '<br>';
          });

          alert.error(message);
        })
      } else {
        this.currentStepIndex++;
        this.currentStep = this.steps[this.currentStepIndex];
        this.configureNavigationButtons();
        this.scrollToTop();
      }
    }

    previousStep() {
      this.currentStepIndex--;
      this.currentStep = this.steps[this.currentStepIndex];
      this.configureNavigationButtons();
      this.scrollToTop();
    }

    configureNavigationButtons() {
      switch(this.currentStep) {
        case this.stepOnePickType:
          this.nextStepLabel = this.nextStepLabelTemplate;
          this.previousStepLabel = this.previousStepLabelTemplate;
          this.showNextStepButton = true;
          this.showPreviousStepButton = false;
          this.showObituaryPrice = false;
          this.disabledNextStepButton = false;
          break;
        case this.stepTwoPickTemplate:
          this.nextStepLabel = this.nextStepLabelTemplate;
          this.previousStepLabel = this.previousStepLabelTemplate;
          this.showNextStepButton = true;
          this.showPreviousStepButton = true;
          this.showObituaryPrice = true;
          this.disabledNextStepButton = false;
          break;
        case this.stepThreePopulateData:
          this.nextStepLabel = this.payStepLabelTemplate;
          this.previousStepLabel = this.previousStepLabelTemplate;
          this.showNextStepButton = true;
          this.showPreviousStepButton = true;
          this.showObituaryPrice = true;
          this.disabledNextStepButton = true;
          break;
        case this.stepFourPay:
          this.nextStepLabel = '';
          this.previousStepLabel = '';
          this.showNextStepButton = false;
          this.showPreviousStepButton = false;
          this.showObituaryPrice = false;
          break;
      }

      this.update();
    }

    scrollToTop() {
      document.body.scrollTop = 0;
      document.documentElement.scrollTop = 0;
    }

    getPriceForObituaryTemplate(id) {
      switch (id) {
        case 1:
          return 1;
        case 2:
          return 2.5;
        case 3:
          return 5;
        default:
          return 0;
      }
    }

    getPriceForObituaryType(id) {
      switch (id) {
        case 1:
          return 10;
        case 2:
          return 10;
        case 3:
          return 10;
        case 4:
          return 10;
        case 5:
          return 10;
        case 6:
          return 10;
        default:
          return 0;
      }
    }

    getPriceForFeaturedObituary(isFeatured) {
      return isFeatured ? 2 : 1;
    }

    calculatePrice() {
      const templateId = parseInt(this.obituary.template_id);
      const typeId = parseInt(this.obituary.type_id);
      const featuredBool = parseInt(this.obituary.is_featured);

      const templatePrice = this.getPriceForObituaryTemplate(templateId);
      const typePrice = this.getPriceForObituaryType(typeId);
      const featuredPrice = this.getPriceForFeaturedObituary(featuredBool);

      let price = (templatePrice * typePrice) * featuredPrice;

      if (templateId === 1 && typeId === 1 && !featuredBool) {
        price = 0;
      }

      this.obituaryPrice = price;
      this.obituaryPriceEur = price / 2 || 0;

      if (this.currentStep === this.stepThreePopulateData) {
        this.nextStepLabel = this.obituaryPrice > 0 ? this.payStepLabelTemplate : this.finishStepLabelTemplate;
      }

      this.update();
    }
  </script>
</obituary-form-main>
